###################################################################################
# Examples Using PemaPopularWords Reference Class
###################################################################################

# Source or run script containing example PemaPopularWords class generator
pkgDir <- path.package("RevoPemaR")
popWordCode <- file.path(pkgDir, "/demoScripts/PemaPopularWords.R")
source(popWordCode)

# Create a simple data frame with character data and a factor
myData <- data.frame(comment = 
       c("Today there will be scattered showers", 
         "Looks like mist, followed by drizzle to me", 
         "I see isolated showers to the west",
         "Sprinkles here",
         "No rain today",
         "Nope, don't see rain.",
         "Hardly ever rains this time of year",
         "I'd like a little rain."),
         state = factor(rep(c("Washington", "Arizona"), each = 4)), stringsAsFactors = FALSE)


# Generate an PemaWordCount object
PemaPopularWords$help(initialize)
myPopularWords <- PemaPopularWords()

#pemaCompute will initialize myWordCount with ... values
out1 <- pemaCompute(myPopularWords, data = myData, minWordSize = 2, varName = "comment")
out1 


##########################################################################################################
# Data set containing Amazon reviews of fine foods
##########################################################################################################


#fineFoodsXdf <- "C:/Revolution/Data/finefoods/finefoods2.xdf"
#Number of observations: 568,455 
#Var 1: productId, Type: character
#Var 2: userId, Type: character
#Var 3: profileName, Type: character
#Var 4: helpfulness, Type: character
#Var 5: reviewScore
       #5 factor levels: 1 2 3 4 5
#Var 6: reviewTime, Type: character
#Var 7: reviewSummary, Type: character
#Var 8: reviewText, Type: character

if ("RevoScaleR" %in% .packages())
{
dataDir <- path.package("RevoPemaR")
foodRev <- file.path(dataDir, "/sampleData/foodrev.xdf")
myPopularWords <- PemaPopularWords()


out1 <- pemaCompute(myPopularWords, data = foodRev, varName = "reviewSummary",
    minWordCount = 5L) 
out1[1:30]
}



