\name{RevoScaleR NEWS}
\title{RevoScaleR NEWS}

\section{CHANGES IN RevoScaleR VERSION 9.2.1}{
  \subsection{DEPRECATED AND DEFUNCT}{
    \itemize{
      \item \code{RxInTeradata} compute context is no longer supported (however,
            the \code{RxTeradata} data source is still supported).
      \item \code{RxHadoopMR} is now deprecated. Consider using \code{RxSpark} compute context instead.
     }         
   }
}

\section{CHANGES IN RevoScaleR VERSION 9.0.0}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item SQL Server R Services package management preview feature. See \code{\link{rxPackage}},
   \code{\link{rxInstalledPackages}},
   \code{\link{rxInstallPackages}},
   \code{\link{rxRemovePackages}},
   \code{\link{rxSqlLibPaths}},   
   \code{\link{rxFindPackage}} for more information.
     }         
   }
}

\section{CHANGES IN RevoScaleR VERSION 8.0.6}{
    \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
        \item \code{rxSortXdf} is now deprecated.  Use \code{rxSort}. 
         \item The argument \code{predNames} in \code{rxPredict} is now defunct. Use \code{predVarNames}
or \code{residVarNames}.
      }      
   }    
}

\section{CHANGES IN RevoScaleR VERSION 8.0.5}{
    \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
        \item \code{rxImportToXdf} is now deprecated.  Use \code{rxImport}. 
        \item \code{rxDataStepXdf} is now deprecated.  Use \code{rxDataStep}. 	    
        \item \code{rxXdfToDataFrame} is now deprecated.  Use \code{rxDataStep}.   
      }      
   }    
}

\section{CHANGES IN RevoScaleR VERSION 8.0.3}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item SQL Server improvements are covered on MSDN: 
        \url{http://msdn.microsoft.com/en-us/library/mt604847.aspx}.
      \item A new distributed compute context \code{RxSpark} is available, in which
       computations are parallelized and distributed across the nodes of a Hadoop cluster
       via Apache Spark. This provides up to a 7x performance boost compared to \code{RxHadoopMR}.       
     }         
   } 
   \subsection{BUG FIXES}{
    \itemize{
        \item \code{rxKmeans} now works with an \code{RxHadoopMR} compute context and
 an \code{RxTextData} data source.
         \item When writing to an \code{RxTextData} data source using \code{rxDataStep},
 specifying \code{firstRowIsColNames} to \code{FALSE} in the output data source will now
 correctly result in no column names being written.
         \item When writing to an \code{RxTextData} data source using \code{rxDataStep},
 setting \code{quoteMark} to \code{""} in the output data source will now result
 in no quote marks written around character data. 
         \item When writing to an \code{RxTextData} data source using \code{rxDataStep},
 setting \code{missingValueString} to \code{""} in the output data source will now result
 in empty strings for missing values. 
          \item Using \code{rxImport}, if \code{quotedDelimiters} was set to \code{TRUE}, 
 transforms could not be processed.
          \item \code{rxImport} of \code{RxTextData} now reports a warning instead of an error if
 mismatched quotes are encountered.
          \item When using \code{rxImport} and appending to an \code{.xdf} file, a combination
 of the use of \code{newName} and \code{newLevels} for different variables in \code{colInfo} 
 could result in \code{newLevels} being ignored, resulting in a different set of factor levels 
 for the appended data.
	}
  }   
}

\section{CHANGES IN RevoScaleR VERSION 8.0.1}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item An new internal variable, \code{.rxPredict} is available inside transformation
      functions to indicate that the data is being processed from a prediction rather
      than a model estimation.
     }         
   }
     
    \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item \code{rxGetVarInfoXdf} and \code{rxGetInfoXdf} are now defunct.  
	    Use \code{rxGetVarInfo} and \code{rxGetInfo}.
	    \item \code{rxDataFrameToXdf} is now deprecated.  Use \code{rxDataStep}.
	    \item The argument \code{covariance} in \code{rxLinMod} is now defunct.
      }      
   }      
   \subsection{BUG FIXES}{
    \itemize{
        \item When using \code{rxPredict}, with an in-formula transformation
        of the dependent variable, an error was given if the variable
        used in the transformation was not available in the prediction
        data set.
	}
  }
}

\section{CHANGES IN RevoScaleR VERSION 8.0.0}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item Fuzzy matching algorithms and are available as experimental in \code{rxGetFuzzyKeys}
      and \code{rxGetFuzzyDist}
     }         
   }
     
    \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item 'NIEDERR' is no longer supported as a type of random number generator.
      }
   }      
   \subsection{BUG FIXES}{
    \itemize{
        \item When using \code{rxDataStep}, new variables created in a transformation no longer inherit 
        the \code{.rxLowHigh} attribute of the variable used to create them.   
        \item \code{rxImport} was not allowing an \code{RxXdfData} data source as the \code{inData} argument.
	}
  }
}

\section{CHANGES IN RevoScaleR VERSION 7.5.0}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item A new RxInSqlServer compute context and RxSqlServerData data source are included
       for use with SQL Server 2016 CTP3.
       \item The RxOdbcData data source now has write capability.
     }         
   }
     
  \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item 'scheduleOnce' is now defunct for rxPredict.rxDForest and rxPredict.rxBTrees.
	    \item 'RxLsfCluster' is now defunct.
	    \item 'RxHpcServer' is now deprecated.
      }
   }       
   \subsection{BUG FIXES}{
    \itemize{
        \item rxGetInfo was failing when an extended class of RxXdfData was used.   
        \item rxGetVarInfo now respects the 'newName' element of colInfo for a non-xdf data source. 
        \item If 'inData' for rxDataStep is a non-xdf data source that contains a colInfo specification
        using 'newName', the newName should now be used for 'varsToKeep' and 'varsToDrop'.    
	}
  }
}

\section{CHANGES IN RevoScaleR VERSION 7.4.1}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item The RevoScaleR two-process architecture is now available on HPC Server and in Teradata. 
      The in-Teradata compute context now allows:
      \itemize{
		\item in-database memory limits to be modified without a database restart
        \item multiple instances of the rxExec() function to run concurrently with each other and with the other RRE in-Teradata functions
		\item Teradata systems with non-AMP nodes such as 'FICON' nodes
		}
      
      \item Using \code{rxDataStep} with an \code{RxTextData} output data source with an HDFS file system is now
        implemented as EXPERIMENTAL.
     }         
   }
     
  \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item Support for HPC Server 2008 is now deprecated.
      }
   }       
   \subsection{BUG FIXES}{
    \itemize{
        \item ROC computations now exclude observations if the actual or any of the predicted values are missing.
        \item Performance in \code{RxInTeradata} of \code{rxGetInfo} and \code{rxGetVarInfo} when \code{computeInfo} is 
           \code{TRUE} has been improved for large data sets.
        \item Occassional 'BxlServer.exe has stopped working' errors are now being handled.
        \item The in-Teradata compute context now uses fewer thread resources, permitting it to run alongside high intensity workloads.
	}	
  }
}	
\section{CHANGES IN RevoScaleR VERSION 7.4.0}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item RevoScaleR version 7.4 now has a two-process architecture'R itself runs in one process, 
        while RevoScaleR's underlying computational engine runs in a separate process. 
       \item The new function \code{rxNaiveBayes} performs classification using Bayes Theorem to 
         determine the probability that an observation belongs to a certain class.
       \item A new argument, \code{keepStepCoefs}, has been added to the \code{rxStepControl} function. 
         If \code{TRUE}, a data frame \code{stepCoefs} will be returned with the fitted model with rows 
         corresponding to the coefficients and columns corresponding to the iterations. 
         Additional computation may be required to generate the coefficients at each step. 
         Those stepwise coefficients can be visualized by plotting the fitted model with \code{rxStepPlot}. 
       \item Performance has been improved for \code{rxImport} when importing many columns from a text file.                 
       \item Fitting of tree-based models is now faster in most cases because splits are found in parallel. 
          (In the relatively rare case where you are building shallow trees on data sets with 
          few variables, it can be faster to set the \code{findSplitsInParallel} flag to \code{FALSE}.)
        \item Prediction on \code{rxDForest} and \code{rxBTrees} objects has been speeded 
          up by performing the prediction in a single pass over the data. 
        \item \code{rxMerge} can now take a list of data sources to merge.       
     }         
   }
     
  \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item The \code{rxGetVarInfoXdf} and \code{rxGetInfoXdf} functions are now deprecated.
	    Use \code{rxGetVarInfo} and \code{rxGetInfo}.  
      }
   }       
   \subsection{BUG FIXES}{
    \itemize{
        \item When writing to an \code{RxTextData} data source, \code{firstRowIsColNames} set to
          \code{FALSE} is now respected.
        \item rxPredict now checks the levels of all factor variable if \code{checkFactorLevels} 
        is set to \code{TRUE}. 
        \item \code{rxDataStep} now handles fixed width character data when returning a data frame.
        \item Importing integer data from csv file as fixed width character data now works.
	}	
  }
}	

\section{CHANGES IN RevoScaleR VERSION 7.3}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item The \code{rxBTrees} function provides decision forests fitted
        by stochastic gradient boosting. Regression models and both binary and 
        multi-class classification models are supported.
      \item New function \code{as.randomForest} allows coercion
        of \code{rxDForest} to \code{randomForest} objects; this can be used
        to improve performance in prediction, particularly on Hadoop platforms. 
        (See the \emph{RevoScaleR Hadoop
        Getting Started Guide} for an example.) Coerced objects are also
        suitable for use with the \pkg{pmml} package.
      \item New function \code{as.gbm} allows coercion
        of \code{rxBTrees} objects to \code{gbm} objects. As with \code{as.randomForest},
        this can improve performance in prediction, particularly on Hadoop platforms.
     }         
   }
     
   \subsection{BUG FIXES}{
    \itemize{
      \item When a non-decimal variable is converted to a decimal variable in
a transform, is is now stored by default as a double-precision numeric in
an .xdf file.
      \item When a call to rxDataStep results in no rows and no \code{outFile}
is specified, \code{NULL} is now returned and a warning is issued.
	}	
  }
}	

\section{CHANGES IN RevoScaleR VERSION 7.2}{
  \subsection{NEW FEATURES}{
      \itemize{
        \item The \code{rxTeradataDropTable} and \code{rxTeradataTableExists} functions
can now optionally take a data source with a table specification as its \code{table}
argument.
        \item The \code{rxSetVarInfo} function can now be used to change variable names,
factor level names, and low/high values (used in the \code{F()} function) for
composite XDF files in HDFS. Only the composite metafile is rewritten.	
        \item The \code{rxFactors} function can now be used to to create or recode
factor variables in a composite XDF file in HDFS.  A new file must be written out.      
        \item The \code{combineDelimiters} and \code{quoteMark} arguments are now
supported in \code{RxTextData} data sources with \code{useFastRead} set to 
\code{TRUE}.	
      }           
   }
     
   \subsection{BUG FIXES}{
    \itemize{
      \item The \code{numCoresToUse} argument of \code{rxOptions} is now being
respected by the nodes of an LSF cluster when performing RevoScaleR high-performance
analytics.
      \item Jobs running in-database on Teradata no longer build up empty Rtmp directories
in the system tmp directory.
      \item The \code{rxReadXdf} function and \code{rxGetInfo} functions were ignoring
\code{startRow} is set to a number larger than 2147483647.
	  \item The \code{rxDataStep} function now reports a warning when \code{maxRowsByCols}
is exceeded. 
      \item The \code{rxDTree} function has an improved error message when the \code{fweights}
argument is set incorrectly.      
	  \item The \code{rxGetVarInfo} function now returns \code{1} as the low value for
a factor variable, and the number of levels as the high value.
      \item When using \code{rxDataStep} to write to a \code{.csv} file, character data 
were ignoring the missing value string.   
      \item When using an \code{RxTextData} data source with a delimited text data file 
without column names and with \code{useFastRead} set to \code{FALSE}, the column names
now default to \code{V1, V2}, etc.  
      \item \code{rxImport} was failing with an error when \code{varsToDrop} and 
\code{transforms} were both used with an input data frame.
      \item Error handling has been improved when importing data from a delimited text data file
with a varying number of columns.
	}	
  }
}	
\section{CHANGES IN RevoScaleR VERSION 7.1}{
  \subsection{NEW FEATURES}{
      \itemize{
        \item The new \code{RxInTeradata} compute context provides high-performance
in-database analytics in Teradata.
	    \item The \code{RxHadoopMR} compute context can now be used from an edge
or cluster node without ssh. 
        \item Hadoop clusters configured in \emph{run-as-user} mode are now supported.
        Users of such clusters should specify \code{usingRunAsUserMode=TRUE} when
        defining their \code{RxHadoopMR} compute contexts.      
	    \item You can now specify \code{low} and \code{high} values for variables in 
\code{colInfo} in data sources and for \code{rxImport}.   
        \item A new \code{RxDataSource} functions allows creation of a new data source
 based on an existing data source.
	    \item The \code{RxTextData} data source function has a new argument
\code{quotedDelimiters}.  If set to \code{TRUE}, delimiters
 within quoted strings will be ignored.
	   }	      
   }
  \subsection{DEPRECATED AND DEFUNCT}{
      \itemize{
	    \item The \code{RxAzureBurst} compute context is now defunct.  
      }
   }      
   \subsection{BUG FIXES}{
    \itemize{
	  \item The \code{rxCov}, \code{rxCor}, and \code{rxSCCP} functions can now be used
with a \code{transforms} argument in a distributed compute context.
      \item A memory leak when writing character data to a compressed .xdf file has
been fixed.
      \item The \code{RxLsfCluster} and \code{RxHpcServer} compute contexts now use
the \code{numCoresToUse} set in \code{rxOptions} for the compute nodes, unless the number
of physical cores on the machine is less than \code{numCoresToUse}.
      \item \code{rxKmeans} now respects the \code{blocksPerCompositeFile} slot of a composite xdf outFile.
      \item The \code{outFile} argument for \code{rxCube} is now supported in an \code{RxHadoopMR} compute context.
      \item When printing data sources, information about non-default settings is now included.
      \item A comma-delimited text data file without column names and with all character data was failing 
with \code{rxImport}.
      \item Labels for \code{rxHistogram} are improved when using non-xdf data sources 
with \code{startVal} and \code{endVal} specified.
	  \item The functions \code{rxLogit} and \code{rxGlm} now support specification of low and
high values with \code{F} in a formula, e.g. \code{F(x, low = 1, high = 10}.
 	  \item The functions \code{rxLogit} and \code{rxGlm} no longer remove all missings on read. 
 	  \item The function \code{rxGetVarInfo} will no longer compute factor levels for non-xdf
data sources unless \code{computeInfo} is set to \code{TRUE}.
	  \item When using \code{rxImport}, if \code{varsToKeep} included all variables in order, 
the \code{colInfo} specification was lost.
      \item Handling of warning and error messages has been improved when using \code{rxImport}
with a delimited text file containing a varying number of columns per row.   
	}
  }
}	   

\section{CHANGES IN RevoScaleR VERSION 7.0.0}{
  \subsection{NEW FEATURES}{
      \itemize{
	    \item The new \code{RxHadoopMR}compute context allows  
	      RevoScaleR analysis functions such as\code{rxLinMod}, \code{rxSummary}, and 
	      \code{rxLogit} to have computations automatically distributed across a Hadoop cluster. 
	       Your data files can be in .csv or .xdf format. High performance computing on Hadoop
	       is also supported through the \code{rxExec} function.
	    \item The \code{rxStepControl} function has a new argument \code{stepCriterion} 
	      which defaults to AIC but allows specification of \code{stepCriterion="SigLevel"} 
	      to allow SAS-like stepwise regression where variables to be added or dropped are 
	      compared to the current model using F or Chi-squared tests of significance. Significance 
	      levels for entry to or removal from the model can be specified with the new arguments 
	      \code{maxSigLevelToAdd} and \code{minSigLevelToDrop}. 
	    \item The new argument \code{removeDupKeys} allows you to remove duplicates 
	      while sorting. The first record with a unique combination of the \code{sortByVars} 
	      is retained; subsequent records with the same combination are removed.  If 
	      desired, a new variable can be created containing the  number of records that 
	      match each combination. This can be used as a frequency weight in subsequent 
	      analyses.
	    \item The default \code{xdfCompressionLevel} in \code{rxOptions} is now set
	      to one.
	    \item When numeric data are imported as \code{logical} variables, any valid non-zero
	      values are now set to \code{TRUE}.  This is consistent with the behavior of
	      \code{as.logical}. 
	    \item In \code{rxImport}, data frames can now be used as inData in a local compute context. 
	    \item In \code{rxDataStep} and \code{rxPredict}, an \code{RxTextData} delimited
	     text data source can be used as the \code{outFile} in a local compute context.
		\item The \code{rxOptions} function now contains an \code{outDataPath} argument
	      used to specify a default directory for writing .xdf files from RevoScaleR
	      functions. (Not supported with the RxHadoopMR compute context).     
	    \item The \code{dataPath} argument for \code{rxOptions} and data sources
	      is now fully respected; the current working directory is not included
	      in the search path unless explicitly included  with \code{"."}.   
	    \item The local compute contexts, \code{RxLocalSeq}, \code{RxLocalParallel}
	      and \code{RxForeachDoPar}, now have slots for a default
	      \code{dataPath} for reading files used in RevoScaleR functions, and a default
	      \code{outDataPath} for writing files from RevoScaleR functions.
	    \item The distributed compute contexts, \code{RxHpcServer}
	      and \code{RxLsfCluster},  now have slots for a default 
	      \code{outDataPath} for writing files from RevoScaleR functions.	
	    \item New methods \code{as.lm}, \code{as.glm}, \code{as.rpart}, and \code{as.kmeans}
	       convert appropriate RevoScaleR model objects to objects of class \code{lm},
	       \code{glm}, \code{rpart}, and \code{kmeans}, respectively. The underlying structure 
	       of the output object will be a subset of that produced by an equivalent call to
		   corresponding function. In many cases, this method can be used to coerce an object
		   for use with the \pkg{pmml} package.      
	    \item The list returned from \code{rxGetInfo} now returns a \code{compressionType}
	      component for \code{.xdf} files.
	    \item The function \code{rxDataFrameToXdf} now returns an \code{RxXdfData} object
	      representing the \code{.xdf} file.
	    \item The function \code{rxXdfToText} now returns an \code{RxTextData} object
	      representing the output text file.
	    \item The argument \code{userObjects} in \code{rxDataStepXdf},
	      \code{rxImportToXdf}, \code{rxTextToXdf}, and \code{rxXdfToDataFrame} 
	      is now defunct.
	   }
   }
   \subsection{BUG FIXES}{
    \itemize{
	  \item The \code{xdfCompressionLevel} argument in \code{rxTextToXdf} is now
	  supported.
	  \item The \code{rxPredict} function no longer incorrectly reports an error 
	    message when offset terms are used with \code{rxGlm}.
	  \item Converting a logical to an integer in a \code{transform} is now supported.
	  \item RxTextData data sources with \code{useFastRead} set to {TRUE} now respects
	   the {rowsPerRead} argument after the first iteration for iterative algorithms.

	}
  }
}	   

\section{CHANGES IN RevoScaleR VERSION 6.2.1}{
  \subsection{NEW FEATURES}{
    \itemize{
	  \item Platform LSF 8 and Platform LSF 9 are now 
	  supported, together with Platform LSF 7. 
	}
  }
  \subsection{BUG FIXES}{
    \itemize{
      \item Improved support for accessing data from .xdf files in HDFS.
	  \item Compressing .xdf files containing fixed-width string data now
	  works correctly.
	  \item Computations with \code{rxExec} involving exported data should now
	  be much faster when using a local parallel compute context.
	  \item Negative decimal data were not being handled properly in the
	   \code{RxTeradata data source}. 
	  \item The \code{rxKmeans} function now works with compressed .xdf files.
	}
  }
}

\section{CHANGES IN RevoScaleR VERSION 6.2.0}{
  \subsection{NEW FEATURES}{
    \itemize{
	  \item The new \code{RxTeradata} function provides a high-speed Teradata 
	    data source that takes advantage of 
	    the Teradata Parallel Transporter (TPT). 	
	  \item New argument \code{variableSelection} to \code{rxLinMod} allows
	    stepwise model selection. New function \code{rxStepControl} can be used
	    to construct the \code{variableSelection} argument.
	  \item The \code{rxImport} function and \code{RxTextData} data source now 
	    support a faster fixed format text data import option. The\code{useFastRead} 
	    option is now available for a fixed format \code{RxTextData} data source, 
	    which corresponds to the new \code{"fixedFast"} import type for \code{rxImport}. 
	    This option is now the default for fixed format data. 
	  \item New arguments \code{byGroupOutFile} and \code{summaryStats} to 
	    \code{rxSummary} allow by-group statistics written directly to one or more
		.xdf format data files.
	  \item New argument \code{outFile} to \code{rxCube} allows cube output to
	    be written directly to a .xdf format data file. This can be useful when
	   the cube is extremely large and unlikely to be directly manipulable in
	    memory.
	   \item New argument \code{byGroupOutFile} to \code{rxSummary} allows
	   summary statistics computed by group(s) to be written to one or more
	   .xdf data files.
	   \item New argument \code{summaryStats} to \code{rxSummary} allows
	   users to choose a subset of summary statistics to report.
	  \item New functions \code{rxRngNewStream}, \code{rxRngGetStream}, 
	    \code{rxRngSetStream}, and \code{rxRngDelStream} provide an R interface to 
	    the parallel random number generators supplied with the Intel MKL libraries. 
	    These allow high quality parallel random numbers to be used in distributed 
	    computations performed by the \code{rxExec} function.
	  \item New arguments \code{RNGkind} and \code{RNGseed} to \code{rxExec} allow 
	    specification of parallel random number streams in the \code{rxExec} workers. 
	    The \code{RNGkind} argument can be used to specify any of the generators 
	    supported by \code{rxRngNewStream}, and the \code{RNGseed} argument can be used 
	    to set a seed, ensuring reproducibility of results.
	  \item New arguments \code{dropMain} and \code{CoefLabelStyle} to
	    \code{rxOptions}, \code{rxLinMod}, \code{rxGlm}, and \code{rxLogit} allow
	    output more similar to that of \code{lm} and \code{glm}.
      \item Coefficients in models with interaction terms fit with
	    \code{rxLinMod}, \code{rxGlm}, and \code{rxLogit} can be made
	    to match those of equivalent models fit with \code{lm} or 
	    \code{lm} by setting \code{dropMain=FALSE} and 
	    \code{coefLabelStyle="R"}.
	  \item The \code{rxDTreeBestCp} function attempts to find the best value of cp for 
	    pruning an rxDTree object. Providing the argument \code{pruneCp="auto"} to
	    the \code{rxDTree} function causes \code{rxDTreeBestCp} to be called on the
	    fitted tree and the pruned tree to be returned.
	  \item The default buffer size for rxMerge and rxSort has been changed
	    to try to make better use of available memory.
	  \item There are performance improvements for estimated models with many variables.
      \item Version numbering scheme amended to match that of Revolution R Enterprise.	  
	}	  
  }
  \subsection{BUG FIXES}{
    \itemize{
      \item By default, if \code{inData} is an \file{.xdf} file, \code{rxSplit} will 
        create new \file{.xdf} files for the split data rather than returning a list of
        data frames. To create data frames from an \file{.xdf} file, set \code{outFilesBase = ""}.
      \item The dataPath was sometimes not being respected for HPA functions in 
        a distributed context.
	  \item The 'Date' column type can now be specified in colClasses for SPSS 
	    and SAS data sources.
	  \item The computation of models involving terms with small or no variance has 
	    been improved.
	  \item If both \code{numRows} and \code{rowsToSkip} arguments were specified for 
		\code{rxImport}, sometimes the the incorrect number of rows was being imported.
      \item Extra linefeeds are now ignored in a delimited \code{RxTextData} data source
        with \code{useFastRead} set to \code{TRUE}.
	  \item \code{rxImport} with type \code{textFast} now supports fixed width 
	    character variables with delimited text files using a non-standard delimiter.
	  \item \code{rxImport} will respect the \code{type} argument to change the
	    setting of \code{useFastRead} in an input text data source.
	  \item \code{rxLinePlot} now supports 'blank' as a symbolStyle to omit the rendering
	    the symbol.
	  \item Renaming a Date or POSIXct type column using \code{rxSetVarInfo()} no longer changes
	    the variable type.
	  \item \code{rxGetInfo()} now returns the number of rows for \code{RxSas} and 
	    \code{RxSpss} data sources. 
	  \item Handling of high-order interaction terms in models has been improved.
	  \item The \code{col.names} argument can now be used in \code{rxXdfToText()} to
	    suppress the writing of column names.   
     }
  }
}

\section{CHANGES IN RevoScaleR VERSION 3.1-0}{
  \subsection{NEW FEATURES}{
    \itemize{
	  \item New function \code{rxDTree} for creating classification
	  and regression tree models. 
	  \item The \code{rxPredict} function is now generic and has a
	  method for \code{rxDTree} models.
	  \item Text and .xdf files stored in Hadoop Distributed File Systems
	  (HDFS) can now be read and used by RevoScaleR functions. A new
	  function \code{rxSetFileSystem} can be used to specify the file
	  system as a global option (either \code{"native"} or
	  \code{"hdfs"}). The argument \code{fileSystem} has been added to
	  the \code{RxTextData} and \code{RxXdfData} data source generator
	  functions, and the \code{str} and \code{show} methods for \code{RxXdfData} 
	   provide information on the file system type.
	  \item RevoScaleR defaults to using no more than
	  four cores on a multicore machine; some customers with many-core 
	  machines have reported performance degredation with many 
	  cores competing for data. This can be changed using 
	  \code{rxOptions(numCoresToUse=)}.
	  \item A new data type has been added for fixed-width character
	  data. This data type is now always used for character data from
	  fixed-width text data files, and can be used with other input data
	  files by specifying \samp{width=n} as part of a \code{colInfo} 
	  argument.
	  \item New function \code{rxCompressXdf} for compressing existing
	  .xdf files.  Also new argument \code{xdfCompressionLevel} to 
	  \code{rxImport} and \code{rxDataStep} (among others)
	  to set the compression level for the output .xdf file.	
	  \item Function \code{rxQuantile} has additional arguments providing
	  more user control over computations.
	}
  }
  \subsection{BUG FIXES}{
    \itemize{
	   \item The \code{dataPath} argument to distributed contexts can be used
	   to specify multiple data paths for RevoScaleR HPA functions; previously, data files 
	   needed to be located in the same location on all nodes.
	   \item The \code{rxLogit} function now continues and completes calculations
	   when extreme values are encountered. Previously, computations would
	   occassionaly stop prematurely and report additional missing values.
	   \item The \code{rxLogit} and \code{rxGlm} functions now checks and
	   report errors for the unsupported use of high/low values with \code{F} 
	   in the formula.
	   \item The \code{rxFactors} function's \code{sortLevels} argument
	   now works for non-factor variables provided the \code{levels} 
	   argument is also supplied. Previously you also had to specify
	   \code{newLevels}.
	   \item The \code{rxRoc} function now provides a warning if
	   no plot can be drawn because there are no positive or 
	   no negative actual observations.
	   \item The \code{rxHistogram} function now supports rotated
	   axis labels.
       \item Binary datatypes in SQL databases are now
	   imported correctly.	
       \item \code{RevoScaleR} functions will now look for data files first
       in any locations specified by \code{dataPath} argument for \code{rxOptions}
       before looking in the current working directory.
       }
     }
  }

 \section{CHANGES IN RevoScaleR VERSION 3.0-1}{
  \subsection{NEW FEATURES}{
    \itemize{
	  \item The \code{continueOnFailure} argument to \code{rxExec}
	  now defaults to \code{TRUE}.
	  \item New functions \code{rxSetEnableThreadPool} and
	  \code{rxGetEnableThreadPool} can be used to set and get
	  the current thread pool state on Linux. By default, the
	  thread pool is disabled on Linux to allow R sessions
	  involving RevoScaleR computations to be forked successfully.
	  Users who are sure they will not be using fork to spawn
	  new processes involving RevoScaleR can enable the thread pool
	  by calling \code{rxSetEnableThreadPool(TRUE)} after loading
	  RevoScaleR.
	  \item New function \code{rxPingNodes}. This function provides 
	  a simple test of the compute context's ability to perform a round 
	  trip through one or more computation nodes. 
	}
  }
  \subsection{BUG FIXES}{
    \itemize{
	  \item The Azure Burst compute context now uses https instead of http
	  to communicate between the desktop and Azure nodes.
	  \item The way in which remote R processes are terminated was changed 
	  in HPC Server and Azure Burst compute contexts to avoid occasional 
	  failures to return state correctly.
	  \item The \code{rxGetInfo} and \code{rxGetVarInfo} functions now work
	  correctly with .xdf files in distributed compute contexts when called 
	  within a function.
	  \item The \code{rxCancelJobs} function now works correctly in LSF
	  compute contexts.
	  \item \code{RxLocalParallel} on Linux now uses a snow-like backend, 
	  rather than a multicore-like backend that could cause R to stop working when used
	  with an HPA function such as \code{rxGlm} or \code{rxLinMod}.
	  \item \code{RxLsfCluster} compute contexts now use \code{$TEMP}
	  as the default working directory if \code{$HOME} does not exist
	  or is not writable.
	  \item The \code{rxGetJobs} function now works correctly if 
	  \code{exactMatch=TRUE}.
	  \item The \code{rxSort} function now returns the correct number of rows if sorting an
	  .xdf file using multiple sort keys and setting the type to 'varByVar'.
	  \item The \code{rxPredict} function now works with non-xdf data sources
	  as long as predictions are written to an .xdf or returned as a data
	  frame, and now works with a data frame when only one variable is
	  used in the model. Transformed variables are now also returned if the 
	  input data is a data frame and \code{writeModelVars=TRUE}. 
	  \item The \code{rxQuantile} function now works with non-xdf data
	  sources, and now has \code{fweights} and \code{pweights} arguments.
	  \item For fast text import, \code{rowsToSkip} with the first row as
	  column names no longer imports all data as character data. It will
	  also now issue a warning and continue (rather than stopping with an
	  error) if a row of data is encountered with too few columns. The
	  remaining columns are filled with NA.
      \item The \code{rxFactors} function is faster and uses less memory
      in cases where there are a large number of factor levels.
		  
	   
	}
  }
}
\section{CHANGES IN RevoScaleR VERSION 3.0-0}{
  \subsection{NEW FEATURES}{
    \itemize{
	  \item New function \code{rxGlm} implements generalized linear 
      models. The \code{rxGlm} function supports the binomial, gamma,
	  Poisson, and Tweedie families natively, but also supports all
	  valid R family objects.
	  \item New function \code{RxLsfCluster} allows for creation of
      a compute context that will distribute computations across
      the nodes and/or cores of a Linux cluster running Platform 
	  LSF. 
	  \item New function \code{RxAzureBurst} allows for creation of
	  a compute context that will distribute computations from a
	  local Microsoft HPC Server head node to Azure nodes using Azure Burst.
	  \item New function \code{RxForeachDoPar} allows for creation of
	  a compute context that will distribute \code{rxExec} computations 
	  across a registered \code{foreach} backend.
	  \item New function \code{RxLocalParallel} allows for creation of
	  a compute context that will distribute \code{rxExec} computations 
	  locally using the base \pkg{parallel} package.	
	  \item New function \code{RxLocalSeq} allows for creation of
	  a compute context that will run \code{rxExec} computations 
	  sequentially on the local machine.	
	  \item New function \code{rxSetComputeContext} sets a compute
	  context object to be active.
	  \item New function \code{rxGetComputeContext} gets the
	  currently active compute context object.	  	    
	  \item Function \code{rxGetNodes} has been deprecated and
	  replaced with \code{rxGetAvailableNodes}.  Function \code{rxGetNodeInfo}
	  has been modified and enhanced.
	  \item RevoScaleR analysis functions (\code{rxSummary}, \code{rxCube},
	  \code{rxCrossTabs}, \code{rxLinMod}, \code{rxCovCor} and related functions, 
	  \code{rxLogit}, \code{rxGlm}, and \code{rxKmeans} now support analysis of
	  non-XDF data sources (\code{RxTextData}, \code{RxSpssData}, \code{RxSasData},
	  \code{RxOdbcData}) directly. (Note, however, that for repeated analyses
	  of a single data set, it is almost always faster to start 
	  with conversion to the .xdf format.)	  
	  \item New function \code{rxSplit} expands on existing ability
	  to split .xdf files and provides ability to split data frames
	  as well as .xdf files, and returns either a list of data frames
	  or a list of \code{RxXdfData} data sources.
	  \item New function \code{rxQuantile} computes approximate
	  quantiles for (appropriate for large data sets). 
	  \item New functions \code{rxRoc} and \code{rxRocCurve} plot
	  ROC curves using actual and predicted data from a binary response
	  model.	
	  \item New function \code{rxLorenz} computes and plots
	  Lorenz curves.	   
	  \item \code{rxPredict} now returns a \code{data.frame} if the
	  input \code{data} is a \code{data.frame}. \code{rxPredict} also now 
	  supports adding predicted values to an existing .xdf file by 
	  setting overwrite to FALSE.
	  \item Distributed computing job objects have changed; jobs
	  created with RevoScaleR Version 2.0-0 or 2.0-1 are not 
	  compatible with RevoScaleR 3.0-0. If you have older jobs on 
	  your HPC Server cluster, extract all data from them and 
	  delete them before installing RevoScaleR Version 3.0-0.
	  \item New argument \code{rowBuffering} to 
	  \code{RxOdbcData} can be used to turn off row buffering
	  if you encounter difficulty importing with specific ODBC
	  drivers (set \code{rowBuffering=FALSE} in such cases).
	  \item the \code{rxFactors} function now can be used to easily convert 
	  all factors to have sorted levels; simply use \code{rxFactors(data, sortLevels=TRUE)}.
	  The \code{rxFactors} function also now works when a distributed 
	  compute context is active.
	  \item The \code{F()} function now works with factor variables.
	  \item The \code{RxOdbc} data source now supports importing binary 
	  data types from SQL databases.
	  \item Intercept-only models are now supported in \code{rxLinMod}, 
	  \code{rxLogit}, and \code{rxGlm}.
	  \item The \code{rxLogit} function now returns p-values based 
	  on the Z-statistic rather than on the t-statistic for consistency
	  with \code{rxGlm}.	  
	}
  }
  \subsection{BUG FIXES}{
    \itemize{
	  \item \code{rxImport} now correctly handles recasting a character column
	  as type \code{numeric} using the \code{colClasses} argument, and correctly
	  imports data in scientific notation.
	  \item RevoScaleR now respects thread control settings from the
	  \code{setMKLthreads} function.
      \item \code{rxLogit} has improved internal handling of models that result
      in extreme values in an iteration.  It also now includes the computation
      of starting values in the number of iterations, and more gracefully handles
	  incorrectly specified \code{transformVar} arguments.
	  \item Importing ODBC data with the \code{useFastRead=TRUE} flag
	  has improved handling of missing values and logical data.
	  \item The \code{rxFactors} function now ignores trailing spaces in
	  factor levels.
	  \item The \code{execObjects} argument to \code{rxExec} is now
	  correctly handled when passed an environment.
      \item \code{rxMerge} was not always returning all rows for
      types \code{"left"} and \code{"full"}. Also, union merges could
	  sometimes fail even though both files had the same variable names
	  and identical sets of factor levels for all factor variables.
      \item \code{rxPredict} now adds variables to an existing data set if
      \code{overwrite} is set to \code{FALSE}. If \code{writeModelVars} is
      set to \code{TRUE} and transformations are in the model used for
      predictions, \code{rxPredict} now correctly writes out all model variables 
      when writing to a new multi-block file. The \code{writeModelVars} argument 
      for is now supported when the input data is a data frame. Also,
	  \code{rxPredict} now returns either a data frame or an XDF data source
	  for consistency with other analysis function return values.
      \item \code{rxHistogram} now always properly includes the lower bound
      for continuous data.
      \item When \code{fweights} are used with \code{rxLogit} or \code{rxLinMod},
      the total observations reported now shows the total number of weighted
      observations.
	  \item Performance of many computations involving data frames
	  has been improved.
	  \item Performance of \code{rxSplit} has been improved in the
	  case where you split on the levels of a factor.
	  \item RevoScaleR now loads correctly on Linux systems when R is 
	  started via JRI.
	  \item	The \code{rxLogit} function now returns p-values based on the 
	  Z-statistic rather than on the t-statistic for consistency with rxGlm.
	  \item \code{rxLogit} and \code{rxGlm} now report correct degrees 
	  of freedom if there are fweights.
	  \item rxPredict no longer fails if F() with low and high is used in the model formula.
	  \item The \code{F()} function now allows missings to be treated as out-of-range 
	  thus counted in the rxOther category when \code{exclude} is
	  set to \code{TRUE}, and can be used on factor variables together with
	  high and low values to exclude certain levels from the analysis.
	}
  }
}

\section{CHANGES IN RevoScaleR VERSION 2.0-1}{
  \subsection{BUG FIXES}{
    \itemize{
	\item \code{rxKmeans} with missing values was sometimes incorrectly 
	  reporting the number of valid and missing observations.
	\item \code{rxMerge} was erroneously returning \code{FALSE} if the 
	  \code{outfile} argument had no xdf extension, even though the merge 
	  was successful. Also, the use of the \code{newVarNames} arguments was 
	  sometimes leading to the renaming of additional variables.    
	\item \code{rxSetVarInfo} now returns an \code{RxXdfData} object if the 
	  input data is an .xdf file.  If the input data is a data frame,
	  a data frame is returned.
	\item \code{rxFactors} now returns an \code{RxXdfData} object if an 
	  output file is specified.  Otherwise a data frame is returned.  
	\item \code{rxImport} will now import data files specified
	  in a web URL.         
    \item \code{registerDoRSR} was not behaving correctly in a
      distributed compute context with \code{wait = FALSE}.
    \item \code{RxHpcServer} was not behaving correctly if names of all 
      nodes in the cluster came alphabetically after the string 
      \code{'Local Client.'}           
    }
  }   
}     

\section{CHANGES IN RevoScaleR VERSION 2.0-0}{
  \subsection{NEW FEATURES}{
    \itemize{
    
     \item New function \code{RxHpcServer} allows for creation of
      a compute context that will distribute computations across
      the nodes and/or cores of an HPC Cluster.
     
      \item New option \code{computeContext} in the \code{rxOptions} 
      function allows users to set (and switch between) a compute 
      context utilizing an HPC cluster and a compute cluster using
      the local computer. If set to an HPC cluster context, RevoScaleR
      analysis functions (\code{rxSummary}, \code{rxCube}, 
	  \code{rxCrossTabs}, \code{rxLinMod}, \code{rxLogit},
	  \code{rxCovCor} (and related functions), and \code{rxKmeans}) will
      be automatically distributed across nodes of the cluster.
      
      \item New function \code{rxExec} allows for distribution
      of arbitrary functions across nodes or cores of a cluster
      when the \code{rxOptions} \code{computeContext} argument
      is set to a context utilizing an HPC cluster.
	  
	  \item New parallel backend \pkg{doRSR} allows \code{foreach}
	  computations to be distributed  across a cluster
	  via the \code{rxExec} function, or locally using \pkg{doSMP}.
	  
	  \item New versatile \code{rxImport} function for using external
	  data with R (delimited and fixed format text, SAS, SPSS, or
	  ODBC). Smaller data sets can be imported directly in R data
	  frames; larger data sets can be stored in the native .xdf
	  data format. Either can be used in subsequent data analysis
	  functions.
	  
	  \item New versatile \code{rxDataStep} function allows you to
	  perform data transformations on small or large data sets using
	  the full power and flexibility of the R language. Experiment
	  with a small data frame, then apply the same code to a huge
	  data set. Easily convert data frames to .xdf files and 
	  vice versa. Also can be used to \dQuote{re-block} .xdf files
	  with a user-specified number of rows.

      \item New function \code{rxMerge} allows a variety of merge
      techniques on two .xdf files and/or data frames. Supported 
      mergers include join types inner, left, right, full, and union, 
      and the one-to-one merge type found in SAS.
	  
	  \item Sorting performance in \code{rxSortXdf} has been improved.
	  A new function \code{rxSort} can now be used to sort either
	  a data frame or an .xdf file.
	  
	  \item New function \code{rxFactors} provides the ability to
	  create and recode factors in .xdf files or data frames.
	  
	  \item New function \code{rxSplitXdf} allows you to split
	  an .xdf file by number of rows, blocks, or levels of a factor
	  variable.
	  
	  \item New variable types (ordered factors and POSIXct) are 
	  allowed in .xdf files. Support for the Date data type has been
	  improved.
	  
	  \item New functions \code{rxGetVarInfo}, \code{rxGetInfo}, and
	  \code{rxSetInfo} work for both data frames and .xdf files.
	  
	  \item New functions for working with contingency table output
	  (that is, output from \code{rxCrossTabs}, \code{rxCube}, or
	  \code{xtabs}): 
	    \itemize{
		  \item \code{rxChiSquaredTest}: Chi-squared test
		  \item \code{rxFisherTest}: Fisher's exact test
		  \item \code{rxKendallCor}: Kendall's tau rank correlation coefficient
		  \item \code{rxPairwiseCrossTab}: Apply a function to all pairwise combinations
		  of the rows and columns of an \code{xtabs} object, stratifying by higher
		  dimensions
		  \item \code{rxRiskRatio}: Calculate the relative risk ratio on a two-by-two
		  table
		  \item \code{rxOddsRatio}: Calculate the relative odds ratio on a two-by-two
		  table
		  \item \code{rxMultiTest}: Collects a list of tests for variable independence
		  into a table.
       }
	  
      \item Improved handling of user-specified transformations 
	  in \code{rxImport}, \code{rxDataStep}, \code{rxSummary},
      \code{rxLinMod}, and other analysis functions. Improvements
	  include a new argument \code{transformPackages} to specify 
      additional packages to load when computing transformations,
      a new argument \code{transformEnvir} to specify an evaluation
	  environment for the transformations, new internal variables
	  \code{.rxNumRows} (the number of rows in the current chunk) and
	  \code{.rxTransformEnvir} (the environment containing any
	  \code{transformObjects}), and three new internal functions for
	  operating on objects in the transform environment: \code{.rxGet},
	  \code{.rxSet}, and \code{.rxModify}.
      Also, the argument \code{userObjects} has been deprecated and 
      replaced with \code{transformObjects}.

      \item New option \code{byTerm} in the \code{rxSummary} function,
      which is now the default, computes summaries on a term-by-term
      basis. With this option, only values missing from the single
      term are omitted from the computations. Previously (and now
      if \code{byTerm=FALSE}, all observations containing missing
      values were omitted, and then the summaries were computed on
      the resulting data set.
      
	  \item New function \code{rxResultsDF} for extracting a
	  data frame from results returned by \code{rxCrossTabs},
	  \code{rxSummary}, and \code{rxLinMod}.
	  
	  \item Improved performance for scalable analysis functions
	  operating on data frames.
	  
	  \item New argument \code{byTerm} to \code{rxSummary} (default
	  \code{TRUE}) to remove missing values by term, rather than
	  by row as previously. The earlier behavior can be obtained by
	  setting \code{byTerm=FALSE}.
	  
	  \item New argument \code{dropFirst} to \code{rxLinMod} and
	  \code{rxLogit} (default \code{FALSE}) to drop first or last
	  factor levels.
	  
	  \item New argument \code{initialValues} to \code{rxLogit} to
	  set starting parameter values.
	  
	  \item The \code{rxHistogram} function now supports logical data
	  and frequency weights with continuous data, and now includes
	  the \code{transforms} and related arguments.
	  
      \item New data source \code{RxOdbcData} 
	  allows import to .xdf files from a wide 
      variety of database management systems.

      \item New argument \code{writeModelVars} to 
      \code{rxPredict} and \code{rxKmeans} to allow all variables used 
	  in the model to be written out with the predicted values (and 
	  residuals, if requested) or cluster assignment.

    }
  }
  \subsection{BUG FIXES}{
    \itemize{
      \item \code{rxKmeans} gave an access violation error if a
      character variables was stored in the .xdf data source.

      \item \code{rxSortXdf} was returning incorrect values for
      \dQuote{Total number of rows written}.

      \item \code{rxPredict} now gives an error when a model with
      multiple dependent variables is supplied.
   
      \item Interrupting \code{rxSortXdf} calls could result in
      errors in later function calls.
    }
  }
}
\section{CHANGES IN RevoScaleR VERSION 1.2-0}{
  \subsection{NEW FEATURES}{
    \itemize{
      \item New function \code{rxKmeans} performs k-means clustering
      by means of external memory implementation of Lloyd's algorithm.

      \item New data source \code{RxSpssData} permits import of SPSS 
      data.

      \item New argument \code{userObjects} to functions supporting
      the \code{transforms} and \code{transformFunc} arguments allows
      passing user objects from your search path to the 
      sterilized evaluation environment used to evaluate
      transform functions.
      
      \item New elements \code{newName}, \code{description}, and 
      \code{newLevels} supported by the \code{colInfo} argument to the
      \code{rxTextToXdf} function and the data sources \code{RxTextData},/
      \code{RxSasData}, and \code{RxSpssData}. These can be used to
      modify or add information to a variable.

      \item New argument \code{numRows} to \code{rxImportToXdf} allows 
      reading a portion of a data file as a preview to help in setting
      import options.

      \item Data source \code{RxTextData} now supports the \code{Date}
      class (stored in .xdf files as 64-bit float).
 
      \item Function \code{rxCovCor} now returns standard deviations of
      the variables in the \code{StdDevs} output object for 
      \code{type="Cov"}.  
 
      \item Import of fixed-format text and SAS data is much faster than
      before.   
      
      \item New function \code{rxSortXdf} provides efficient multikey
      sorting of the variables in an .xdf file. 
    }
  }

  \subsection{BUG FIXES}{
    \itemize{
      \item \code{rxTextToXdf} now correctly imports columns of
      \code{TRUE} and \code{FALSE} entries as a logical 
      variable.

      \item \code{rxReadXdf} is now faster when 
      \code{returnDataFrame = TRUE}.

      \item The \code{stringsAsFactors} argument to 
      \code{rxTextToXdf} and data sources is now given
      lower precedence than the \code{colInfo} and 
      \code{colClasses} arguments.

      \item \code{rxCovCor} no longer produces errors
      when all columns have no variance.

      \item \code{rxHistogram} now correctly plots and
      labels factors with a single level.

      \item \code{rxImportToXdf} is now faster at 
      importing text and SAS data.
 
      \item \code{rxDataFrameToXdf} now gives correct
      counts for factor levels when one or more levels 
      contains 0 counts.
      
      \item \code{rxTextToXdf} now correctly handles
      blanks as missings in the first column of data.

      \item The escape mechanism has been improved, so
      most RevoScaleR functions can now be interrupted.

      \item \code{rxPredict} no longer produces weighted 
      predictions if the original model includes no weights.

      \item \code{rxLinePlot} now accepts the output of
      \code{rxCube} as input without requiring explicit
      coercion to data frame.

      \item \code{rxImportToXdf} can now correctly convert
      integers to factors and floating point numbers to
      character data.

      \item \code{rxCovCor} now produces the same results
      whether the input data is a data frame or an .xdf file.

      \item \code{rxCovCor} no longer drops constant variables
      when \code{keepAll=TRUE}.
    }
  }
}      
  

\section{CHANGES IN RevoScaleR VERSION 1.1-1}{
  \subsection{NEW FEATURES}{
    \itemize{
       \item A 64-bit Linux port (Red Hat Enterprise Linux 5.4 or 5.5) is
       now available.

       \item New functions \code{rxCovCor}, \code{rxCov}, \code{rxCor},
       and \code{rxSSCP} for generating covariance and correlation 
       matrices from a formula and data without fitting a specific
       model.

       \item New functions \code{rxCorCoef}, \code{rxCorData},
       \code{rxCovCoef}, and \code{rxCovData} give the correlation
       and covariance matrices for the coefficient estimates and
       the explanatory variables in model objects returned by
       \code{rxLinMod} and \code{rxLogit}.

       \item New RevoScaleR options for \code{defaultDecimalColType}
       and \code{defaultMissingColType} can also be specified
       as arguments to \code{rxTextToXdf}. The \code{defaultDecimalColType}
       option can be specified as an argument to \code{RxTextData}.

       \item The \code{rxImportToXdf} function now supports 
       delimited text data. This is an alternative to 
       \code{rxTextToXdf}.

    }
  }
  \subsection{DEPRECATED AND DEFUNCT}{
    \itemize{
       \item The argument \code{autoDetectColNames} to 
       \code{rxTextToXdf} has been deprecated; use
       \code{firstRowIsColNames = NULL} to request 
       auto-detection.
    }
  }
  \subsection{BUG FIXES}{
    \itemize{
       \item The \code{transforms} argument is now significantly faster when
       many transforms are performed because fewer copies of the list elements
       are made.

       \item Read-only .xdf data files can be analyzed using RevoScaleR.

       \item The functions \code{rxLinMod} and \code{rxLogit} have 
       greatly reduced memory requirements when \code{cube} is set
       to \code{TRUE} and \code{cubePredictions} is \code{FALSE}.

       \item \code{rxTextToXdf} can now import \code{TRUE}/\code{FALSE}
       and \code{T}/\code{F} values as logicals if specified as such in 
       \code{colClasses}. Blanks are treated as missings.

       \item \code{rxTextToXdf} no longer creates multiple levels for
       repeated occurrences of the blank string \code{" "}. Specifying
       a level \code{.rxOther} puts all missing data into a level of that
       name.

       \item \code{rxXdfToDataFrame} and \code{rxReadXdf} now return a
       data frame when \code{maxRowsByCols} is exceeded. The data frame
       contains the maximum number of rows implied by the \code{maxRowsByCols}
       argument.
 
       \item \code{rxPredict} now reports an error if the factor levels
       in the new data do not match the factor levels in the model
       object (up to 1000 levels). For efficiency reasons, this check can
       be turned off with the \code{checkFactorLevels} argument.

       \item \code{rxPredict} now works correctly if the variables
       in the new data are in a different order than those in the
       data used to fit the model object.

       \item \code{rxPredict} now respects the \code{blocksPerRead}
       argument, except in the case where the input and output files
       are the same, in which case \code{blocksPerRead} is always set
       to 1.

       \item \code{rxTextToXdf} now reports an error if you try to 
       append rows to an existing data file with a different number
       of columns, or with differently named columns.

       \item \code{rxTextToXdf} now  reports an error if you try to 
       append data of a different type to an existing variable. 
       Previously, it coerced the new data to the existing type, often
       resulting in missing data.

       \item \code{rxHistogram} now reports an error if an expression
       is supplied as a primary variable.
 
       \item \code{rxHistogram} now starts bars at 0 for factors.
    }
  }
}

\section{CHANGES IN RevoScaleR VERSION 1.1-0}{
  \subsection{NEW FEATURES}{
    \itemize{
       \item A beta Linux port (Red Hat Enterprise Linux 5.4 or later)
       is now available.
     
       \item A new function \code{rxImportToXdf} permits conversion of 
       fixed-format text data and SAS data sets (.sas7bdat files only)
       to .xdf format. 

       \item New data sources \code{RxTextData} and \code{RxSasData} allow
       reading fixed-format and SAS data.

       \item The \code{XdfData} data source has been renamed 
       \code{RxXdfData} and has undergone thorough revision. See
       \code{\link{RxXdfData}} for current details.

       \item Most functions now include a \code{transforms} argument
       that takes a named list of expressions to create or modify
       variables. These expressions are evaluated in a 
       \dQuote{sterilized} environment with the \pkg{base} package
       as its parent. This gives consistent evaluation, but also
       requires that you use a package prefix and the double colon
       operator to use functions outside the base package in your
       transformations.

       \item A much wider range of input formulas is now supported.
       Formulas that include calls to I() are generally acceptable, as
       are most inline transformations. (Functions such as 
       \code{poly} that return matrix predictors are still unsupported.)
   
       \item A new function \code{rxXdfToDataFrame} allows you to read
       a (sufficiently small) subset of rows and variables from an .xdf 
       to an R data frame in memory.

       \item Many functions have undergone argument re-ordering; 
       argument ordering is now much more consistent across functions.
  
       \item The \code{reportProgress} argument now defaults to the
       value specified in \code{rxGetOption("reportProgress")}, and
       that option now defaults to \code{2}.

       \item The \code{overwrite} argument now defaults to \code{FALSE}
       instead of \code{NULL}.
       
       \item The \code{append} argument now defaults to \code{"none"}
       instead of \code{NULL}.
       
       \item New variables \code{.rxStartRow}, \code{.rxChunkNum},
       \code{.rxReadFileName}, and \code{.rxIsTestChunk} are now
       available to functions specified as \code{transformFunc} 
       arguments or in \code{transforms} argument expressions 
       (for local compute contexts).

       \item The \code{colInfo} argument to \code{rxTextToXdf} can
       now be supplied as a named list, and can be used to supply
       data type information for types other than factors.

       \item The \code{rxCrossTabs} and \code{rxCube} functions
       now include an argument \code{removeZeroCounts}; if 
       \code{TRUE}, rows containing all zeros are removed from 
       the returned contingency table.
       
       \item The \code{rxLinMod} and \code{rxLogit} functions
       now include an argument \code{cubePredictions}.  If
       \code{TRUE} and the \code{cube} argument is \code{TRUE},
       the predicted values are computed and included in the 
       countDF component of the returned value. This may be memory
       intensive.  In previous releases this information was
       always returned. 
       
       \item The \code{rxSummary} function (but not others in 
       \pkg{RevoScaleR}) now accepts formulas of the form 
       \code{~ .} to provide summary data for all variables.

       \item A new function \code{rxGetVarNames} returns just the names
       of variables in a .xdf file or data frame.

       \item Functions specified in the \code{transformFunc} argument
       are now evaluated in a \dQuote{sterilized} environment with the
       \pkg{base} package as its parent. 

       \item The \code{rxLinePlot} and \code{rxHistogram} functions are 
       now fully supported and include some new features and defaults. The
       \code{rxHistogram} function will bin continuous data.  For
       faster computation using a bin for every integer value, use
       the F() function.

       \item Summary output for \code{rxLinMod} and \code{rxLogit} now
       includes p-value significance stars.       

       \item The \code{print} and \code{summary} methods for analysis 
       objects now include information about the data frame or data file
       used. They also include information about weights used in the 
       model (probability or frequency). 
       
      \item The \code{rowsPerRead} argument to \code{rxTextToXdf} now
      defaults to 500000, instead of \code{NULL} (which implied reading
      all rows).
	
    }
}
  \subsection{DEPRECATED AND DEFUNCT}{
    \itemize{
      \item Non-integer values for the \code{reportProgress} argument
      are deprecated.
     
      \item Non-logical values for the \code{overwrite} argument are
      deprecated.

      \item Non-character values for the \code{append} argument are 
      deprecated.

      \item Non-integer values for the \code{verbose} argument are
      deprecated.

      \item The \code{covariance} argument to \code{rxLinMod} and
      \code{rxLogit} is deprecated. It is replaced by two new arguments:
      \code{covData} and \code{covCoef} for the variance-covariance
      matrix of the data and of the coefficients, respectively. These
      are prototype arguments.

      \item The analysis functions \code{rxLinMod} and \code{rxLogit}
      no longer return the \code{InverseXX} component. This was not
      the variance-covariance matrix it claimed to be. These functions
      also no longer return the \code{cov.unscaled} component.

      \item The functions \code{rxCrossTabs}, \code{rxCube},
      \code{rxLinMod}, \code{rxLogit}, and \code{rxSummary} are no
      longer S3 generics.

      \item The \code{formula} argument to the \code{rxCube} and 
      \code{rxCrossTabs} functions support only a single predictor 
      term, which may be an interaction. If you want to use 
      multiple variables as predictors in those functions, you must 
      separate them with a colon (\code{:})rather than a plus sign
      (\code{+}).
      }

}
  \subsection{BUG FIXES}{
    \itemize{
      \item Missing values are no longer treated as TRUE when part of
      a row selection variable.

      \item Missing values (NAs) are now  read as floats by default 
      rather than character strings.
  
      \item The \code{rxTextToXdf} function now issues a warning if no
      rows are written out.

      \item The \code{rxTextToXdf} function could fail if the input file
      contained an unnamed column containing row names.

      \item The \code{file} argument for \code{rxReadXdf}, 
      \code{rxGetInfo} and \code{rxGetVarInfoXdf} now have no default
      instead of the former \code{""}.

      \item The counts information returned by \code{rxLogit} could be
      wrong if the argument \code{cube=TRUE} was specified.

      \item Date data is now read in as string data; full date support
      is still on the wishlist.

      \item Help file examples that create files now create them in
      temporary file locations, rather than in the working directory.

	}
    }
}
