__author__ = 'nicr'
import subprocess
import uuid
import shutil
import sys
from Rutility import *

if len(sys.argv) != 3:
    print "illegal arguments"
    exit(-1)

PATH=sys.argv[1]
HDFS_PATH=sys.argv[2]
SEP='\\'
HDFS_SEP="/"

touch(PATH + SEP + 'lastOutputBlock.txt')
echoFile(os.path.normcase(PATH +  SEP + 'jobIdentifier.txt'), 'uninitialized', 'w')
MYUUID=uuid.uuid4()
fname = os.path.normcase(PATH + SEP + str(MYUUID))
echoFile(fname, 'queued', 'w')
shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
touch(PATH + SEP + 'lastOutputBlock.txt')

if( os.getenv("PYTHON_CMD") == None):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'failed', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
    echoFile(os.path.normcase(PATH + SEP + 'MergedOut0.txt'), 'PYTHON_CMD environment variable must be set.  Exiting.', 'a')
    exit()

if( os.getenv("HADOOP_STREAMING") == None):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'failed', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
    echoFile(os.path.normcase(PATH + SEP + 'MergedOut0.txt'), 'HADOOP_STREAMING environment variable must be set.  Exiting.', 'a')
    exit()

if( os.path.exists(os.getenv("HADOOP_STREAMING")) == False):
    MYUUID=uuid.uuid4()
    fname = os.path.normcase(PATH + SEP + str(MYUUID))
    echoFile(fname, 'failed', 'w')
    shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
    echoFile(os.path.normcase(PATH + SEP + 'MergedOut0.txt'), 'HADOOP_STREAMING environment variable must point to a valid file.  Exiting.', 'a')
    exit()

MKDIR_OUTPUT2 = subprocess.Popen("hadoop.cmd fs -mkdir " + HDFS_PATH, stdout=subprocess.PIPE, shell=True)
MKDIR_OUTPUT = MKDIR_OUTPUT2.communicate()[0]

MKDIR_VALUE = MKDIR_OUTPUT2.returncode
if( MKDIR_VALUE == 0):
    os.system("hadoop.cmd fs -chmod a+rwx " + HDFS_PATH) > os.devnull
else:
    GREP_TEST=MKDIR_OUTPUT.find("Permission denied")
    if( GREP_TEST > 0 ):
        MYUUID=uuid.uuid4()
        fname = os.path.normcase(PATH + SEP + str(MYUUID))
        echoFile(fname, 'failed', 'w')
        shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
        echoFile(os.path.normcase(PATH + SEP + 'MergedOut0.txt'), "No permissions to create " + PATH + "  Exiting.", 'a')
        exit()
    DIR_EXISTANCE_TEST2 = subprocess.Popen("hadoop.cmd fs -ls " + PATH, stdout=subprocess.PIPE, shell=True)
    DIR_EXISTANCE_TEST = DIR_EXISTANCE_TEST2.communicate()[0]
    GREP_DIR_EXISTANCE_TEST = MKDIR_OUTPUT.find("No such file or directory")
    if(GREP_DIR_EXISTANCE_TEST > 0 ):
        MYUUID=uuid.uuid4()
        fname = os.path.normcase(PATH + SEP + str(MYUUID))
        echoFile(fname, 'failed', 'w')
        shutil.move(fname, os.path.normcase(PATH +  SEP + 'jobStatus.txt'))
        echoFile(os.path.normcase(PATH + SEP + 'MergedOut0.txt'), PATH + " does not exist, and unable to create.  Exiting.", 'a')
        exit()

output = PATH + SEP + "MergedOut0.txt"
f = open(output, "w")        
COMMAND = "hadoop.cmd jar " + os.getenv("HADOOP_STREAMING") + " -Dmapred.job.map.memory.mb=2500 -Dmapred.task.timeout=3600000 -Dmapred.reduce.tasks=0"
COMMAND = COMMAND + " -inputformat org.apache.hadoop.mapred.lib.NLineInputFormat -input " + HDFS_PATH + HDFS_SEP + "input"
COMMAND = COMMAND + " -output " +  HDFS_PATH + HDFS_SEP + "output -file " + PATH + SEP + "input.R"
COMMAND = COMMAND + " -file " + PATH + SEP + "00.RInData -file " + PATH + SEP + "scaleR.py -mapper \"" + os.getenv("PYTHON_CMD") + " scaleR.py\""

CREATE_NEW_PROCESS_GROUP = 0x00000200
proc = subprocess.Popen(COMMAND, creationflags=CREATE_NEW_PROCESS_GROUP, stderr=f ,stdout=f)


