import os
import getpass
import subprocess
import sys
import glob
if (os.environ.get("MAPREDUCE_TASK_PARTITION") is None):
    MY_RANK = 1
else:
    MY_RANK = int(os.environ.get("MAPREDUCE_TASK_PARTITION")) + 1
sys.stderr.write("MY_RANK= " +str(MY_RANK) + "\n")

sys.stderr.write("CURRENT_DIR= " +str(os.getcwd()) + "\n")

COMMAND="R.exe -e library(RevoScaleR);rxRemoteHadoopMRCall() --no-restore --no-save -q  --args rxCommArgs(rxNetworkShareJobDirectory='" + os.getcwd().replace('\\', '\\\\') +"',rxComputeWhere='manyNodes',rxParametricRank='"+ str(MY_RANK) +"',rxClusterTarget='hadoopmr')"
proc = subprocess.Popen(COMMAND, stderr=sys.stderr ,stdout=sys.stderr)
proc.communicate()

ROUT_FILE_LIST = glob.glob("rxElem*.ROutData")
for name in ROUT_FILE_LIST:
    ROUT_FILE = str(name)
sys.stderr.write("ROUT_FILE_LIST= " + str(ROUT_FILE_LIST) + "\n")
sys.stderr.write("ROUT_FILE= " +ROUT_FILE + "\n")

ROUTDATA_DIR = os.getenv("MAPREDUCE_OUTPUT_FILEOUTPUTFORMAT_OUTPUTDIR")
sys.stderr.write(str(ROUTDATA_DIR) + "\n")
ROUTDATA_DIR=ROUTDATA_DIR.replace("/output", "-output")
if(os.system("hadoop fs -mkdir " + ROUTDATA_DIR) == 0 ):
    sys.stderr.write("mkdir was successful\n")
    os.system("hadoop fs -chmod a+rwx " + ROUTDATA_DIR)
else:
    sys.stderr.write("hadoop mkdir failed - assume the dir already exists\n")
if( os.system("hadoop fs -copyFromLocal " + ROUT_FILE + " " + ROUTDATA_DIR ) == 0):
    sys.stderr.write("copyFromLocal was successful\n")
else:
    if( os.system("hadoop fs -test -e " + ROUTDATA_DIR + "/" + ROUT_FILE ) == 0):
	sys.stderr.write("the output file exists in HDFS - another task attempt must have already generated it\n")
    else:
	sys.stderr.write("the output file does not exist in HDFS - we must exit\n")
	exit(255) # exit as failed
os.system("hadoop fs -chmod a+rw " + ROUTDATA_DIR + "/" + ROUT_FILE)
