from hdinsight_common import hdinsightlogging
from logging.handlers import SysLogHandler 
import base64
import fileinput
import logging
import sys
import urllib2
import getopt
import os

logger = logging.getLogger("MRS")
 
def main(argv):
  message = ''
  level = 'info'
  msgPrefix = 0
  isFile = 0
  prefix = ''
  code = 2
  
  try:
    opts, args = getopt.getopt(argv,"hl:m:p:f:c:")
    arg1 = sys.argv[1]
  except (getopt.GetoptError, IndexError) as e:
    printHelp()
    sys.exit(2)
  for opt, arg in opts:
    if opt == '-h':
      printHelp()
      sys.exit()
    elif opt in ("-l"):
      level = arg
    elif opt in ("-m"):
      message = arg
    elif opt in ("-p"):
      msgPrefix = int(arg)
    elif opt in ("-f"):
      isFile = int(arg)
    elif opt in ("-c"):
      code = int(arg)
     
  if code == 3:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL3)
  elif code == 4:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL4)
  elif code == 5:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL5)
  elif code == 6:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL6)
  elif code == 7:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL7)
  else:
    hdinsightlogging.initialize_root_logger(syslog_facility=SysLogHandler.LOG_LOCAL2)
  
  if msgPrefix == 0:
    prefix = "MRSTelemetry"
  else:
    prefix = "MRSLog"
  
  if isFile == 0:
    doLog(logger, level, prefix + " " + message)
  else:  
    if os.path.isfile(message):
      with open(message) as f:
        for line in f:
          doLog(logger, level, prefix + " " + line)
  
  sys.exit(0)

def doLog(logger, level, message):
  if level == 'info':
    logger.info(message)
  elif level == 'error':
    logger.error(message)

def printHelp():
  print('logScaleR.py -m <message> -l <level (info,error)> -p <message prefix (0,1)> -f <message is a file (0,1)> -r <regex file> -c <facility code>')

if __name__ == '__main__':
  main(sys.argv[1:])

