# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for things related to BxlServer
#
############################################################################################

"test.BxlServer.Rscript" <- function()
{
    # we do not know the path to R binaries for a non-root install so deactive it in such case.
  try.ans <- try(
        ans <- system("Rscript --vanilla -e R.version.string", intern = TRUE), 
        silent = TRUE)
    if (inherits(try.ans, "try-error")) DEACTIVATED("This test is only intended for root install.")
  res <- system("Rscript -e R.version.string", intern = TRUE)
  checkIdentical(ans, res)
}

#"test.BxlServer.basic" <- function()
#{
    #rxPingBxlServer <- RevoScaleR:::rxPingBxlServer
    #rxStartBxlServer <- RevoScaleR:::rxStartBxlServer
    #rxStopBxlServer <- RevoScaleR:::rxStopBxlServer
    #
    #bxlServerPid <- rxPingBxlServer()
    #checkTrue(is.integer(bxlServerPid))
    #
    #oldBxlServerPid <- rxStopBxlServer()
    #checkTrue(bxlServerPid == oldBxlServerPid)
    #newBxlServerPid <- rxPingBxlServer()
    #checkTrue(is.logical(newBxlServerPid) && !newBxlServerPid)
    #
    #newBxlServerPidDefault <- rxStartBxlServer()
    #checkTrue(is.integer(newBxlServerPidDefault))
    #checkTrue(newBxlServerPidDefault != bxlServerPid)
    #
    #newBxlServerPidFalse <- rxStartBxlServer(restart = FALSE)
    #checkTrue(is.integer(newBxlServerPidFalse))
    #checkTrue(newBxlServerPidFalse == newBxlServerPidDefault)
    #
    #newBxlServerPidTrue <- rxStartBxlServer(restart = TRUE)
    #checkTrue(is.integer(newBxlServerPidTrue))
    #checkTrue(newBxlServerPidFalse != newBxlServerPidTrue)
#}

#"test.BxlServer.DeployR.Rserve" <- function()
#{
    #rxPingBxlServer <- RevoScaleR:::rxPingBxlServer
    #rxStartBxlServer <- RevoScaleR:::rxStartBxlServer
    #rxStopBxlServer <- RevoScaleR:::rxStopBxlServer
    #
    #oldBxlServerPid <- rxPingBxlServer()
    #checkTrue(is.integer(oldBxlServerPid))
    #
    #detach("package:RevoScaleR", unload=TRUE)
    #bxlServerPid <- rxPingBxlServer()
    #checkTrue(is.logical(bxlServerPid) && !bxlServerPid)
    #
    ### fork the R process and call the following on the forked process
    #library(RevoScaleR)
    #newBxlServerPid <- rxPingBxlServer()
    #checkTrue(is.integer(newBxlServerPid))
#}

"test.BxlServer.rxGetWorkingSetSize" <- function()
{
  if(RevoScaleR:::rxInDatabaseHostPlatform()) DEACTIVATED("Bug 74518: SQLPAL: wmic not found in azure sandbox")
  
  WorkingSetSize <- RevoScaleR:::rxGetWorkingSetSize(peak = FALSE)
  WorkingSetSizePeak <- RevoScaleR:::rxGetWorkingSetSize(peak = TRUE)
  checkTrue(WorkingSetSize <= WorkingSetSizePeak)
}
