
                                        # Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for general issues with RevoScaleR
#
############################################################################################

.setUp <- function()
{
}

.tearDown <- function()
{
}

revoSysInfo <- data.frame(os=character(), family=character(), majorVersion=character(), identifier=character())

revoSysInfo <- rbind(revoSysInfo, data.frame(os="unknown",  family="unknown", majorVersion="unknown", identifier="unknown"))
revoSysInfo <- rbind(revoSysInfo,data.frame(os="linux", family="RHEL", majorVersion="5", identifier="CentOS release 5.4 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="5", identifier="CentOS release 5.6 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="5", identifier="CentOS release 5.8 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.0 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.1 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.2 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.3 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.4 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.5 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.6 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="CentOS release 6.7 (Final)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.0 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.1 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.2 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.3 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.4 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.5 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.6 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="RHEL", majorVersion="6", identifier="Red Hat Enterprise Linux Server release 6.7 (Santiago)"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="linux",  family="SLES", majorVersion="10", identifier="Welcome to SUSE Linux Enterprise Server 10 SP3 (x86_64) - K"))
revoSysInfo <- rbind(revoSysInfo, data.frame(os="Windows",  family="Windows", majorVersion="unknown", identifier="Windows"))

# sysInf <- revoSysInfo[revoSysInfo$identifier == "CentOS release 5.4 (Final)",]
# sysInf <- revoSysInfo[revoSysInfo$identifier == "Welcome to SUSE Linux Enterprise Server 10 SP3 (x86_64) - K",]

revoSys.info <- function()
{

    sysInf <- revoSysInfo[revoSysInfo$identifier == "unknown",]
    if (Sys.info()["sysname"] == "Windows") {
        sysInf <- revoSysInfo[revoSysInfo$identifier == "Windows",]
    }
    else if (Sys.info()["sysname"] == "Linux")
    {
                                        # depending on first line of /etc/issue return platform

        issueFile <- "/etc/issue"
        if (file.exists(issueFile))
        {
            issueText <- readLines( issueFile )
            newSysInf <- revoSysInfo[revoSysInfo$identifier == issueText[1],]
      if (nrow(newSysInf) > 0)
      {
        sysInf <- newSysInf
      }

        }

    }
    return(sysInf)
}

"test.RevoScaleR.infinite.recursion" <- function()
{
    DEACTIVATED("Does not run properly on the docker container we use for ShipR.")
       
    library(RevoScaleR)
    #library(RUnit)
    numcores <- rxGetOption("numCoresToUse")
    sysInf <- revoSys.info()

    if ((numcores != -1) &&
        ((sysInf$family == "RHEL" && sysInf$majorVersion == "5")
         ||(sysInf$family == "SLES" && sysInf$majorVersion == "11")))
    {
        DEACTIVATED("Defect 6228397 : This test crashes RScript on RHEL5 and SLES11 for cores 1 2 but not -1")
    }

    options(expressions = 500000)
    f <- function() {
        #print(Cstack_info())
        f()
    }

    checkException(f())
}
