# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for things related to BxlServer
#
############################################################################################

"test.rxCluster.extractInputData.data" <- function()
{
  "fake_fun" <- function(data){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(data = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractInputData(callInfo)))
}

"test.rxCluster.extractInputData.inData" <- function()
{
  "fake_fun" <- function(inData){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(inData = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractInputData(callInfo)))
}

"test.rxCluster.extractInputData.inFile" <- function()
{
  "fake_fun" <- function(inFile){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(inFile = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractInputData(callInfo)))
}

"test.rxCluster.extractInputData.file" <- function()
{
  "fake_fun" <- function(file){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(file = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractInputData(callInfo)))
}

"test.rxCluster.extractInputData.invalidInput" <- function()
{
  "fake_fun" <- function(invalidInput){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(invalidInput = RxXdfData(file = "/testpath"))
  checkTrue(is.null(RevoScaleR:::extractInputData(callInfo)))
}

"test.rxCluster.extractOutputData.outData" <- function()
{
  "fake_fun" <- function(outData){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(outData = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractOutputData(callInfo)))
}

"test.rxCluster.extractOutputData.outFile" <- function()
{
  "fake_fun" <- function(outFile){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(outFile = RxXdfData(file = "/testpath"))
  checkTrue(!is.null(RevoScaleR:::extractOutputData(callInfo)))
}

"test.rxCluster.extractOutputData.invalidOutput" <- function()
{
  "fake_fun" <- function(invalidOutput){
    return(RevoScaleR:::rxCallInfo(match.call()))
  }
  callInfo <- fake_fun(invalidOutput = RxXdfData(file = "/testpath"))
  checkTrue(is.null(RevoScaleR:::extractOutputData(callInfo)))
}

"test.rxCluster.extractInputDataFile.xdfWithHdfs" <- function()
{
  checkEquals("/testpath", RevoScaleR:::extractInputDataFile(RxXdfData(file = "/testpath", fileSystem=RxHdfsFileSystem())))
}

"test.rxCluster.extractInputDataFile.hive" <- function()
{
  hiveData <- RxHiveData(table = "table")
  checkEquals(hiveData@dfName, RevoScaleR:::extractInputDataFile(hiveData))
}

"test.rxCluster.extractInputDataFile.parquet" <- function()
{
  parquetData <- RxParquetData(file = "/testpath")
  checkEquals(parquetData@dfName, RevoScaleR:::extractInputDataFile(parquetData))
}

"test.rxCluster.extractInputDataFile.rDataFrame" <- function()
{
  checkEquals("Temp", RevoScaleR:::extractInputDataFile(data.frame()))
}
