# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for rxClusterInterface.R and logics of spark worker HPC entry point
#
############################################################################################

"test.initAndCheckRxRemoteSparkExecCallInput" <- function()
{
  if (.Platform$OS.type != "unix") {
    DEACTIVATED("ONLY FOR UNIX.")
  }
  mockCall <- function(func, args) {
    checkEquals(func, "RxUtil")
    checkEquals(args$USE, "InitializeLogging")
    checkEquals(args$traceLevel, 1)
  }
  RevoScaleR:::.initAndCheckRxRemoteSparkExecCallInput(list(rxNetworkShareJobDirectory="/tmp/test", rxTraceLevel=1), mockCall)
  #.initAndCheckRxRemoteSparkExecCallInput should be successfully called once
}

