# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for rxExec
#
############################################################################################

".setUp" <- function()
{
}

".tearDown" <- function()
{
}

# Verify the order of the results matches
# the order of the input arguments.
"test.RxInSqlServer.Acceptance.rxExec.ReturnOrder" <- function()
{
    if(RevoScaleR:::rxInDatabaseHostPlatform()) DEACTIVATED("Bug 72623: localpar fails in Azure sandbox")
    on.exit(rxSetComputeContext("local"), add = TRUE)
  
    "verifyRxExecOrder" <- function()
    {

        "printParams" <- function(order, delay)
        {
            Sys.sleep(delay)
            return(c(order, delay))
        }

        nIter <- 30
        args = list(
        FUN = printParams,
        order = rxElemArg(as.list(1:nIter)),
        delay = rxElemArg(as.list(10 * runif(nIter))))
        results <- do.call(what = rxExec, args = args)

        # Verify results come back in order of invocation.
        for (idx in 1:length(results)) {
            checkEquals(results[[idx]][1], idx)
        }
    }

    # Local parallel test case.
    rxSetComputeContext(RxLocalParallel())
    rxOptions(numCoresToUse = 10)
    verifyRxExecOrder()
}



