# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for links between R and C++ code
#
############################################################################################


test.rxLinkUtil.rxTestRxWarningsExceptionsAndResults <- function()
{
  # check for std::error			
  message <- tryCatch(
    .Call("Rx_TestRxWarningsAndStdException"),
    error = function(e) e$message)
  checkEquals("There are 2 warnings!", message)
  
  # check for (at least the first) warning... haven't found a way to capture more than one in R			
  message <- tryCatch(
    .Call("Rx_TestRxWarningsAndStdException"),
    warning = function(w) w$message)
  checkEquals("The rain in Spain stays mainly in the plain.", message)
  
  # check for range error
  message <- tryCatch(
    .Call("Rx_TestStdRangeError"),
    error = function(e) e$message)
  checkEquals("The hills are alive!  Well, not really...", message)
  
  # check for correct result, even when warnings are displayed
  result <- .Call("Rx_TestRxWarningsAndResult")
  checkEquals("There are 2 warnings!", result)												
}
      