# Copyright (c) Microsoft Corporation.  All rights reserved.
#
# FUNCTIONS
#    Unit tests for rxMkl functions
#
############################################################################################

"test.rxMkl.version.ok" <- function()
{
    # Make sure we are running against expected MKL.
    mklVersion <- RevoScaleR:::rxVersion.MKL()
    expectedVer <- "2017.0.0"
    errmsg <- sprintf(" : MKL version string '%s' does not contain '%s'", mklVersion, expectedVer )
    checkTrue( grepl( expectedVer, mklVersion, fixed=TRUE ), errmsg )
}

"test.rxMkl.version.sameversion" <- function()
{
    DEACTIVATED("RevoUtilsMath will not be installed when testing BigAnalytics on shipR")
    rxMklVersion <- RevoScaleR:::rxVersion.MKL()
    revoMklVersion <- RevoUtilsMath:::version.MKL()
    errmsg <- sprintf(" : rxMklVersion '%s' is not equal to revoMklVersion '%s'",rxMklVersion,revoMklVersion)
    checkEquals( rxMklVersion, revoMklVersion, errmsg  )
}
