"rxDataStep.data.specialChars" <- function()
{
  # The original bug came from importing the birth data: RA-8042
  myData <- data.frame(DOB_YY = as.integer(rep(1985, times = 20)))
  outFile1 <- tempfile(pattern = "dataStep1", fileext = ".xdf")
  outFile2 <- tempfile(pattern = "dataStep2", fileext = ".xdf")
  outCsv <- tempfile(pattern = "dataStep", fileext = ".csv")
  
  rxDataStep(inData = myData, outFile = outFile1,
    transforms = list(RMEDUC   = factor(seq.int(from=2, by = 0, length.out=length(DOB_YY)), 
    # Note the funny quote in Bachelor
    levels=1:2, labels = c("E's", "Bachelor�s"))),
    overwrite = TRUE)
    
  myData2 <- data.frame(DOB_YY = rep(2000, times = 20),
    RMEDUC = rep(1:2, times = 10))
  write.csv(myData2, file = outCsv, row.names = FALSE)
        
  rxImport(inData = outCsv, outFile = outFile2, 
    colInfo = 
    list(	RMEDUC       = list(type="factor",
        levels=c(as.character(1:2)),
        newLevels = c("E's", "Bachelor�s"))),
        overwrite = TRUE)		

  rxDataStep(inData = outFile2, outFile = outFile1, append = "rows")
  fileInfo <- rxGetInfo( outFile1)
  checkEquals(fileInfo$numRows, 40)
  varInfo <- rxGetVarInfo( outFile1 )
  checkEquals(length(varInfo$RMEDUC$levels), 2)

  file.remove(outFile1)
  file.remove(outFile2)
  file.remove(outCsv)
}