#!/bin/bash

# --- defaults ---------------------------------------------------------
HADOOP_CMD="%hadoopCmd%"
PREFIX="%prefix%"
DFS_DIR="%dfsDir%"
GUID_IN_HDFS="%guidInHdfs%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -hadoopCmd)   HADOOP_CMD="$2"; shift 2;;
    -prefix)      PREFIX="$2"; shift 2;;
    -dfsDir)      DFS_DIR="$2"; shift 2;;
    -guidInHdfs)  GUID_IN_HDFS="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

"${HADOOP_CMD}" fs -rm -r "${PREFIX}${DFS_DIR}" 2>&1 > /dev/null
"${HADOOP_CMD}" fs -rm -r "${PREFIX}${DFS_DIR}-output" 2>&1 > /dev/null
"${HADOOP_CMD}" fs -rm -r "${PREFIX}${GUID_IN_HDFS}" 2>&1 > /dev/null
