#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"
OPTIONAL_ARG=""

# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    *)                OPTIONAL_ARG="$1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

MYSTART=1
if [ -f ${CLUSTER_GUID_DIR}/lastOutputLine.txt ]
then
    MYSTART=$(cat ${CLUSTER_GUID_DIR}/lastOutputLine.txt)
fi
if [ -f ${CLUSTER_GUID_DIR}/MergedOut0.txt ]
then
    NUMLINES=$(wc -l ${CLUSTER_GUID_DIR}/MergedOut0.txt | cut -f1 -d' ')
    if [ $NUMLINES -gt 0 ]
    then
        let NUMLINES-=$MYSTART
        let NUMLINES-=1
        if [ -n "${OPTIONAL_ARG}" ]
        then
            if [ "${OPTIONAL_ARG}" == final ]
            then
                let NUMLINES+=2
            fi
        fi
        tail -n +$MYSTART ${CLUSTER_GUID_DIR}/MergedOut0.txt | head -n $NUMLINES > ${CLUSTER_GUID_DIR}/lastOutputBlock.txt
        let NEWCURLINE=$MYSTART+$NUMLINES
        echo $NEWCURLINE > ${CLUSTER_GUID_DIR}/lastOutputLine.txt
    fi
else
    if [ -f ${CLUSTER_GUID_DIR}/lastOutputBlock.txt ]
    then
        rm ${CLUSTER_GUID_DIR}/lastOutputBlock.txt
    fi
    touch ${CLUSTER_GUID_DIR}/lastOutputBlock.txt
fi
