#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

echo "=== getHadoopStatus.sh ===" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
if [ -f ${CLUSTER_GUID_DIR}/jobStatus.txt ]
then
    set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
    MYSTATE=$1
    if [ $MYSTATE == "canceled" ] || [ $MYSTATE == "finished" ] || [ $MYSTATE == "failed" ]
    then
        exit
    fi
fi
MYSTATE="finished"
MYPID=$(cat ${CLUSTER_GUID_DIR}/jobIdentifier.txt)
echo "MYPID = $MYPID" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
for CURPID in $MYPID
do
    echo "Checking CURPID: $CURPID" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
    if ! ps -p $CURPID > /dev/null 2>&1
    then
        echo "Process not found" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
    else
        MYSTATE="running"
        echo "Process found" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
        MYUUID=$(cat /proc/sys/kernel/random/uuid)
        echo $MYSTATE > ${CLUSTER_GUID_DIR}/$MYUUID
        mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
        sleep 1s
        exit
    fi
done
MYUUID=$(cat /proc/sys/kernel/random/uuid)
echo $MYSTATE > ${CLUSTER_GUID_DIR}/$MYUUID
mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
sleep 1s
