#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

set -- $(<${CLUSTER_GUID_DIR}/jobIdentifier.txt)
MYPID=$1
NOEXITDUMMY=$(source ${CLUSTER_GUID_DIR}/getHadoopStatus.sh)
set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
MYSTATE=$1
if [ $MYSTATE == "running" ] || [ $MYSTATE == "queued" ] || [ $MYSTATE == "undetermined" ]
then
    for CURPID in $MYPID
    do
        echo "Killing CURPID: $CURPID" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
        MYTESTPID=$(pgrep R | grep $MYPID )
        if [ -z "$MYTESTPID" ]
        then
            echo "Process not found" >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
        else
            echo $MYTESTPID >> ${CLUSTER_GUID_DIR}/killJobPidLog.txt
            kill -9 $MYTESTPID
            MYUUID=$(cat /proc/sys/kernel/random/uuid)
            echo "canceled" > ${CLUSTER_GUID_DIR}/$MYUUID
            mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
        fi
    done
fi
sleep 1s
