#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

if [ -f ${CLUSTER_GUID_DIR}/jobStatus.txt ]
then
    set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
    MYSTATE=$1
    if [ $MYSTATE == "cancelled" ] || [ $MYSTATE == "finished" ] || [ $MYSTATE == "failed" ]
    then
        exit
    fi
fi
MYSTATE="finished"
MYPID=$(cat ${CLUSTER_GUID_DIR}/jobIdentifier.txt)
for CURPID in $MYPID
do
    MYTESTPID=$(ps l -p $CURPID | grep "R" | grep "masterNode" | grep "hadoopmr" | grep "HadoopMR_JP" | grep "${CLUSTER_GUID_DIR}" | grep -v grep | awk -F" " '{print $3}')
    if [ -z "$MYTESTPID" ]
    then
        DUMMY=1234
    else
        MYSTATE="running"
        MYUUID=$(cat /proc/sys/kernel/random/uuid)
        echo $MYSTATE > ${CLUSTER_GUID_DIR}/$MYUUID
        mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
        sleep 1s
        exit
    fi
done
MYUUID=$(cat /proc/sys/kernel/random/uuid)
echo $MYSTATE > ${CLUSTER_GUID_DIR}/$MYUUID
mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
sleep 1s
