#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"
HPC_SERVER_CLASS="%hpcServerClass%"
REVO_PATH="%revoPath%"
TRACE_LEVEL="%traceLevel%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    -hpcServerClass)  HPC_SERVER_CLASS="$2"; shift 2;;
    -revoPath)        REVO_PATH="$2"; shift 2;;
    -traceLevel)      TRACE_LEVEL="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic -----------------------------------------------------

#Cannot use vanilla R here, since we need some options from Rprofile
$("${REVO_PATH}" --vanilla --slave -e 'cat(system.file("utils/spark/SafeGuard.out", package="RevoScaleR"))') "${REVO_PATH}" --slave -e "library(RevoScaleR); RevoScaleR:::rxLogHadoopMRJob('${CLUSTER_GUID_DIR}', '${HPC_SERVER_CLASS}')" 2>&1 > /dev/null
touch ${CLUSTER_GUID_DIR}/lastOutputBlock.txt
MYUUID=$(cat /proc/sys/kernel/random/uuid)
echo "queued" > ${CLUSTER_GUID_DIR}/$MYUUID
mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
echo "uninitialized" > ${CLUSTER_GUID_DIR}/jobIdentifier.txt
${REVO_PATH} --no-restore --no-save -q "--args rxCommArgs(rxComputeWhere='masterNode',rxNetworkShareJobDirectory='${CLUSTER_GUID_DIR}',rxClusterTarget='hadoopmr',rxTraceLevel=${TRACE_LEVEL},rxCommType='HadoopMR_JP')" < ${CLUSTER_GUID_DIR}/input.R >> ${CLUSTER_GUID_DIR}/MergedOut0.txt 2>&1 &
COUNTER=0
while [  $COUNTER -lt 15 ]; do
    MYPID=$(ps aux | grep "R" | grep "masterNode" | grep "hadoopmr" | grep "HadoopMR_JP" | grep "${CLUSTER_GUID_DIR}" | grep -v grep | awk -F" " '{print $2}')
    echo $MYPID > ${CLUSTER_GUID_DIR}/jobIdentifier.txt
    if [ -n "$MYPID" ]; then
        exit
    else
        echo $COUNTER >> ${CLUSTER_GUID_DIR}/jobIdDebug.txt
        let COUNTER=COUNTER+1
        sleep 1s
    fi
done
echo "failed" > ${CLUSTER_GUID_DIR}/jobStatus.txt
