#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"
MRS_HADOOP_PATH="%mrsHadoopPath%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    -mrsHadoopPath)  MRS_HADOOP_PATH="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done


# --- script logic ----------------------------------------------------

set -- $(<${CLUSTER_GUID_DIR}/jobIdentifier.txt)
MYJOBID=$1
NOEXITDUMMY=$(source ${CLUSTER_GUID_DIR}/getHadoopStatus.sh)
set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
MYSTATE=$1
if [ $MYSTATE == "running" ] || [ $MYSTATE == "queued" ] || [ $MYSTATE == "undetermined" ]
then
     ${MRS_HADOOP_PATH} job -kill $MYJOBID
fi
