#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"
REVO_PATH="%revoPath%"
USER="%user%"
R_SESSION_PID="%rSessionPid%"
APP_ID="%appId%"
JOB_GUID="%jobGUID%"
WAIT="%wait%"
KILLER_PATH="%killerPath%"


# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir)  CLUSTER_GUID_DIR="$2"; shift 2;;
    -revoPath)        REVO_PATH="$2"; shift 2;;
    -jobGUID)         JOB_GUID="$2"; shift 2;;
    -user)            USER="$2"; shift 2;;
    -rSessionPid)     R_SESSION_PID="$2"; shift 2;;
    -appId)           APP_ID="$2"; shift 2;;
    -wait)            WAIT="$2"; shift 2;;
    -killerPath)      KILLER_PATH="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done

# --- script logic -----------------------------------------------------


set -- $(<${CLUSTER_GUID_DIR}/jobIdentifier.txt)
MYJOBID=$1
NOEXITDUMMY=$(source ${CLUSTER_GUID_DIR}/getHadoopStatus.sh)
set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
MYSTATE=$1
if [ $MYSTATE == "running" ] || [ $MYSTATE == "queued" ] || [ $MYSTATE == "undetermined" ]
then
    ${KILLER_PATH} ${USER} ${R_SESSION_PID} ${APP_ID} ${JOB_GUID} ${WAIT} kill app
    kill -9 $MYJOBID
    MYUUID=$(cat /proc/sys/kernel/random/uuid)
    echo "canceled" > ${CLUSTER_GUID_DIR}/$MYUUID
    mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
fi
