#!/bin/bash

# --- defaults ---------------------------------------------------------
CLUSTER_GUID_DIR="%clusterGUIDDir%"

# --- command-line options ---------------------------------------------
while [ $# -gt 0 ]; do
  case "$1" in
    -clusterGUIDDir) CLUSTER_GUID_DIR="$2"; shift 2;;
    *) echo "WARNING! unknown option $1"; shift;;
  esac
done

# --- script logic -----------------------------------------------------

if [ -f ${CLUSTER_GUID_DIR}/jobStatus.txt ]
then
    set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
    MYSTATE=$1
    if [ $MYSTATE == "canceled" ] || [ $MYSTATE == "finished" ] || [ $MYSTATE == "failed" ]
    then
        exit
    fi
fi
JOBID=$(cat ${CLUSTER_GUID_DIR}/jobIdentifier.txt)
if ! ps -p $JOBID > /dev/null
then
    #handle race condition that HPC job finishs right after previous jobStatus.txt file check (while HPC is running before the check).
    if [ -f ${CLUSTER_GUID_DIR}/jobStatus.txt ]
    then
        set -- $(<${CLUSTER_GUID_DIR}/jobStatus.txt)
        MYSTATE=$1
        if [ $MYSTATE == "canceled" ] || [ $MYSTATE == "finished" ] || [ $MYSTATE == "failed" ]
        then
            exit
        fi
    fi
    # job is not runing and also the jobStatus.txt is not in an end status. Update jobStatus.txt to be undetermined status.
    MYUUID=$(cat /proc/sys/kernel/random/uuid)
    echo "undetermined" > ${CLUSTER_GUID_DIR}/$MYUUID
    mv ${CLUSTER_GUID_DIR}/$MYUUID ${CLUSTER_GUID_DIR}/jobStatus.txt
fi
