# For saving time, execBy result preparer does not need to load RevoScaleR package.
args <- commandArgs(trailingOnly = TRUE)

result.dir <- args[1]
out.data.name <- args[2]
isZip <- as.logical(args[3])

if (isZip)
{
    func <- function(outputDir, zipFileName)
    {
        zipFile <- file.path(outputDir, zipFileName)
        unzip(zipFile, exdir = outputDir)

        outputDirContents <- dir(outputDir)
        iroFileIndexes <- grep("iroFile.*iro", outputDirContents)
        numIros <- length(iroFileIndexes)

        retObject <- list()
        retEnv <- new.env(hash = TRUE)
        for (iroFileIndex in seq(1, numIros))
        {
            iroFilePath <- file.path(outputDir, outputDirContents[[iroFileIndexes[[iroFileIndex]]]])
            objectName <- load(iroFilePath, envir = retEnv)
            outData <- get(objectName, envir = retEnv)
            retObject <- c(retObject, outData)
        }

        return(retObject)
    }

    funcParams <- list(zipFileName = out.data.name)
} else
{
    func <- function(outputDir, froFileName)
    {
        retEnv <- new.env(hash = TRUE)
        filePath <- file.path(outputDir, froFileName)
        outputObjectName <- load(filePath, envir = retEnv)
        retObject <- get(outputObjectName, envir = retEnv)
        return(retObject)
    }

    funcParams <- list(froFileName = out.data.name)
}

jobObject <- list(func = func, funcParams = funcParams)
save(jobObject, file = file.path(result.dir, "job.ROutData"))
