# For saving time, exec result preparer does not need to load RevoScaleR package.
args <- commandArgs(trailingOnly = TRUE)

result.dir <- args[1]
out.data.name <- args[2]
isZip <- as.logical(args[3])

if (isZip)
{
    func <- function(outputDir, zipFileName)
    {
        zipFile <- file.path(outputDir, zipFileName)
        unzip(zipFile, exdir = outputDir)

        outputDirContents <- dir(outputDir)
        goodOutputFileLocations <- grep("rxElem.*ROutData", outputDirContents)
        numOutputObjects <- length(goodOutputFileLocations)

        i <- 1L
        clusterOutputList <- list()
        while (i <= numOutputObjects)
        {
            outputFileName <- outputDirContents[[goodOutputFileLocations[[i]]]]
            outputObjectName <- load(file.path(outputDir, outputFileName))

            legalRCompBasedVarName <- gsub("-", "_", outputFileName)
            legalRCompBasedVarName <- gsub(".ROutData", "", legalRCompBasedVarName)

            if (isTRUE(TRUE %in% as.logical(grep("^rxElem", legalRCompBasedVarName))))
            {
                while (isTRUE(TRUE %in% as.logical(grep("m0", legalRCompBasedVarName))))
                {
                    legalRCompBasedVarName <- gsub("m0", "m", legalRCompBasedVarName)
                }
            }
            tmpList <- list(x = get(outputObjectName))
            names(tmpList) <- legalRCompBasedVarName

            clusterOutputList[legalRCompBasedVarName] <- tmpList
            i <- i + 1L
        }

        return(clusterOutputList)
    }

    funcParams <- list(zipFileName = out.data.name)
} else
{
    func <- function(outputDir, froFileName)
    {
        retEnv <- new.env(hash = TRUE)
        filePath <- file.path(outputDir, froFileName)
        outputObjectName <- load(filePath, envir = retEnv)
        retObject <- get(outputObjectName, envir = retEnv)
        return(retObject)
    }

    funcParams <- list(froFileName = out.data.name)
}

jobObject <- list(func = func, funcParams = funcParams)
save(jobObject, file = file.path(result.dir, "job.ROutData"))
