library(RevoScaleR)
local(rxOptions())

# "reducerScript.R"
# For new Spark prototype (2015-11-25)
args <- commandArgs(trailingOnly = TRUE)
froPath <- args[1]
iroBaseNamePath <-args[2]
iroFilesSize <- as.numeric(args[3])
nameNode <- args[4]
port  <- args[5]
traceLevel            <- as.integer(args[6])
processType           <- "WORKER"
logDir                <- args[7]

if(traceLevel>0) {
    .Call('RxUtil', list(USE='InitializeLogging', traceLevel = traceLevel, processType = processType, logDir = logDir))
}

tryCatch({
  # Get all iro files' paths for merge
  iroPaths <- paste0(iroBaseNamePath, seq(0, iroFilesSize-1), ".iro")

  .Call('RxUtil', list(USE='UpdateIRO', fullPath=iroPaths, inHdfs = FALSE))

  .Call('RxUtil', list(USE='WriteIRO', outputObjectPath=froPath, outputInHdfs = FALSE))
}, error = function(e) {
  print(e)
  quit("no", status = 1)
})

