library(RevoScaleR)

# For new Spark prototype (2015-11-25)
args <- commandArgs(trailingOnly = TRUE)

inputDataPath        <- args[1]
inputDataInHdfs      <- as.logical(args[2])
partitionIndex       <- as.numeric(args[3])
inputObjectPath      <- args[4]
iroOutputPath        <- args[5]
outputDataInHdfs     <- as.logical(args[6])
outputDataPathBase   <- args[7]
traceLevel            <- as.integer(args[8])
processType           <- "WORKER"
logDir                <- args[9]

if(traceLevel>0) {
    .Call('RxUtil', list(USE='InitializeLogging', traceLevel = traceLevel, processType = processType, logDir = logDir))
}


.Call( 'RxUtil', list( USE='SetSplitInfo', fileName=inputDataPath, start=0, length=-1 ) ) # length of -1 means read all bytes

taskId <- as.integer(partitionIndex)
taskAttemptId <- 0
if (outputDataInHdfs) {
    .Call( 'RxUtil', list(USE='ComputeHadoopTask', 
        taskId=taskId, 
        taskAttemptId=taskAttemptId, 
        inputObjectPath=inputObjectPath, 
        inputInHdfs = FALSE, 
        outputObjectPathBase=iroOutputPath, 
        outputInHdfs = FALSE,
        inputDataInHdfs = inputDataInHdfs
    ))
} else {
    .Call( 'RxUtil', list(USE='ComputeHadoopTask', 
        taskId=taskId, 
        taskAttemptId=taskAttemptId, 
        inputObjectPath=inputObjectPath, 
        inputInHdfs = FALSE, 
        outputObjectPathBase=iroOutputPath, 
        outputInHdfs = FALSE,
        inputDataInHdfs = inputDataInHdfs,
        outputDataPathBase = outputDataPathBase,
        outputDataInHdfs = FALSE
    ))
}
