doRSR.chunkSize.stress <- function()
{
	library(doRSR)
	library(RUnit)

	registerDoRSR()
	x <- iris[which(iris[, 5] != "setosa"), c(1, 5)]
	trials <- 1000
	chunkSize <- ceiling(trials/1)
	rsropts <- list(chunkSize = chunkSize)
	ptime <- system.time({
		 r <- foreach(icount(trials), .combine = cbind, .options.rsr = rsropts) %dopar%
		 {
			ind <- sample(100, 100, replace = TRUE)
			result1 <- glm(x[ind, 2] ~ x[ind, 1], family = binomial(logit))
			coefficients(result1)
		 }
		 })[3]
	ptime

	chunkSize <- ceiling(trials/5)
	rsropts <- list(chunkSize = chunkSize)
	ptime <- system.time({
		 r <- foreach(icount(trials), .combine = cbind, .options.rsr = rsropts) %dopar%
		 {
			ind <- sample(100, 100, replace = TRUE)
			result1 <- glm(x[ind, 2] ~ x[ind, 1], family = binomial(logit))
			coefficients(result1)
		 }
		 })[3]
	ptime

	chunkSize <- ceiling(trials/10)
	rsropts <- list(chunkSize = chunkSize)
	ptime <- system.time({
		 r <- foreach(icount(trials), .combine = cbind, .options.rsr = rsropts) %dopar%
		 {
			ind <- sample(100, 100, replace = TRUE)
			result1 <- glm(x[ind, 2] ~ x[ind, 1], family = binomial(logit))
			coefficients(result1)
		 }
		 })[3]
	ptime
}
"test.doRSR.chunkSize.stress" <- function()
{
    res <- try(doRSR.chunkSize.stress())
    checkTrue(!is(res, "try-error"), msg="doRSR chunkSize stress test failed")    
}


